

load('H_total.mat')

ev=[];

for i=1:33 %33 num individuals
    vol=H(i).i; 
		  surf=isosurface(vol,0.505);
			[A, C] =FEM(surf); %FEM from http://brainimaging.waisman.wisc.edu/~chung/lb/
			
			[V, D] = eigs(C,A,999,'sm');
			ev(i,:)=sort(diag(D),'descend');
		
end
	
	
	%Reuter et al. 2006 -> Sect. 6.2: Euclidean distance 
	%BrainPrint: Sect. 2.1: 
	
	Yclass=[repmat(1,1,15) repmat(2,1,18)];

	num=10; %first eigenvectors
	enum=[];
	
	for num=1:29% error for > 29
	
	X=ev(:,1:num);
	
	e=0; %number of errors
	for i=1:33
	  
   indi=ones(33,1);
 indi(i)=0;
 indi=logical(indi);
	 Mdl = fitcknn(X(indi,:),Yclass(indi),'NumNeighbors',1,'Distance','mahalanobis');
	class = predict(Mdl,X(i,:));
	e=e + double(class~=Yclass(i));
	
%if(class~=Yclass(i))

%[i,class]

	%end
	
	end
	enum(num)=e;
	
	end
	
	end
	
	
    16    16    18    12    18    16    17    16    18    17    17    18    17    18    17    17    14    18    18    17    20    17    15    15    17    16     9    11    12
	
	%%%%%%%%%%%%
	%Double-cross-validation for selection number of eigenvalues
	
	numT=28; %for numT> 28 return error
	
   erl=zeros(33,numT); %matriz de errores global

ee=[];
for num=1:numT
e=0;
	X=ev(:,1:num);



for i=1:33
    
   indi=ones(33,1);
 indi(i)=0;
 indi=logical(indi);
 
 

 s=setdiff(1:33,i);
errores=0;
for j=s
    
    indi2=ones(33,1);
    indi2(i)=0;
    indi2(j)=0;
   indi2=logical(indi2);
   
		 Mdl = fitcknn(X(indi2,:),Yclass(indi2),'NumNeighbors',1,'Distance','mahalanobis');
	class = predict(Mdl,X(j,:));
	errores=errores + double(class~=Yclass(j));
   

end

erl(i,num)=errores;

end

 
end


figure
plot(1:numT,sum(erl,1)) % minimum in 27 (9 errors) 

sum(erl,1)

	
	509   512   568   388   575   515   546   510   583   563   559   567   518   581   505   540   464   508   570   572   603   542   473   484   481   498   379   399 
	
	%%%%%%%%%%%%%%%%%%%%%%%%%
	
	%Linear re-weigthing
	
		%Linear re-weigthing
	Yclass=[repmat(1,1,15) repmat(2,1,18)];
	

	num=10; %first eigenvectors
	enum=[];
	
	for num=1:29% error for > 29
	
	X=ev(:,1:num);
	rw=repmat([1:num],33,1);
	X=X./rw;
	
	e=0; %number of errors
	for i=1:33
	  
   indi=ones(33,1);
 indi(i)=0;
 indi=logical(indi);
	 Mdl = fitcknn(X(indi,:),Yclass(indi),'NumNeighbors',1,'Distance','euclidean');
	class = predict(Mdl,X(i,:));
	e=e + double(class~=Yclass(i));
	
%if(class~=Yclass(i))

%[i,class]

	%end
	
	end
	enum(num)=e;
	
	end
	
	
	
	
  %enum
 %16    16    15    15    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14    14

%> 33-14
%[1] 19
%> 19/33
%[1] 0.5757576
	
	%%%%%%%%%%%%
	%Double-cross-validation for selection number of eigenvalues
	
	numT=28; %for numT> 28 return error
	
   erl=zeros(33,numT); %matriz de errores global

ee=[];
for num=1:numT
e=0;
	X=ev(:,1:num);

	rw=repmat([1:num],33,1);
	X=X./rw;
	

for i=1:33
    
   indi=ones(33,1);
 indi(i)=0;
 indi=logical(indi);
 
 

 s=setdiff(1:33,i);
errores=0;
for j=s
    
    indi2=ones(33,1);
    indi2(i)=0;
    indi2(j)=0;
   indi2=logical(indi2);
   
		 Mdl = fitcknn(X(indi2,:),Yclass(indi2),'NumNeighbors',1,'Distance','euclidean');
	class = predict(Mdl,X(j,:));
	errores=errores + double(class~=Yclass(j));
   

end

erl(i,num)=errores;

end

 
end


figure
plot(1:numT,sum(erl,1)) % minimum at  5(14  errors) 

sum(erl,1)

	
  
   509   509   479   479   449   450   450   450   450   450   450   450   450   450   450   450   450   450   450   450   450   450   450   449   449   449   449   449

	
	
	

	
	