%%%%%%%%%%%%%%%%%%%%%%
%CALCULATINGFOURIER.M%
%%%%%%%%%%%%%%%%%%%%%%



load('H_total.mat')

n=11; %L
Fl=[];

for i=1:33 %33 num individuals
    vol=H(i).i; 
    surf=isosurface(vol,0.505); 
    [amyg,sphere,amygsphere]=CREATEenclosedamyg22(vol,surf); %slightly modified from surfstats
    stream=LAPLACE3Dsmooth(amygsphere,amyg,-sphere);
    
    %from surfstats
    sphere=isosurface(amyg,0.505);
    
    for alpha=1:5
        sphere=LAPLACEcontour(stream,sphere, 1 - 2*alpha/5); % from surfstats
        sphere=REGULARIZEarea2(sphere, 0.8); %slightly modified from surfstats
    end
    
    [surf_smooth, fourier]=SPHARMsmooth2(isosurface(amyg,0.505),sphere,n,0); %from surfstats
    Fl=[Fl,fourier];
end

 save('calcu_four_todos_11','Fl')