
 library(R.matlab)


da=readMat('calcu_four_todos_11.mat')


cxyz=c();


 
    

g=c(rep(1,15), rep(2,18));



nrep=33;

for (i in 1:nrep){
    
		da$Fl[,,1]

    r=which(da$Fl[,,i]$x != 0)  #son los distintos de cero
    s=which(da$Fl[,,i]$y != 0)
    t=which(da$Fl[,,i]$z != 0)
		
		x=da$Fl[,,i]$x
		y=da$Fl[,,i]$y
		z=da$Fl[,,i]$z
    
    cxyz=rbind(cxyz, cbind(t(x[r]) ,t(y[s]) ,t(z[t]) )   );
    
}

xmi=cxyz;

###########

library(MASS)
library(klaR)

pr = prcomp(cxyz) ;
coica=pr$x

summary(pr)


%Importance of components:
%                          PC1    PC2    PC3    PC4     PC5     PC6     PC7     PC8     PC9   PC10    PC11    PC12    PC13    PC14    PC15    PC16    PC17    PC18
%Standard deviation     0.6686 0.5893 0.5060 0.3601 0.28580 0.24747 0.22624 0.20077 0.18573 0.1835 0.15887 0.14917 0.14197 0.13488 0.13305 0.12758 0.12417 0.11442
%Proportion of Variance 0.2589 0.2011 0.1483 0.0751 0.04731 0.03547 0.02964 0.02335 0.01998 0.0195 0.01462 0.01289 0.01167 0.01054 0.01025 0.00943 0.00893 0.00758
%Cumulative Proportion  0.2589 0.4601 0.6084 0.6835 0.73077 0.76624 0.79589 0.81923 0.83921 0.8587 0.87333 0.88622 0.89789 0.90843 0.91868 0.92811 0.93704 0.94462
%                          PC19    PC20    PC21    PC22    PC23    PC24    PC25    PC26    PC27    PC28    PC29    PC30      PC31      PC32      PC33
%Standard deviation     0.11255 0.10863 0.10123 0.10028 0.09049 0.08816 0.08541 0.08030 0.07819 0.07384 0.07238 0.06584 4.736e-15 1.872e-16 3.966e-17
%Proportion of Variance 0.00734 0.00683 0.00593 0.00582 0.00474 0.00450 0.00423 0.00373 0.00354 0.00316 0.00303 0.00251 0.000e+00 0.000e+00 0.000e+00
%Cumulative Proportion  0.95196 0.95879 0.96473 0.97055 0.97529 0.97980 0.98402 0.98776 0.99130 0.99445 0.99749 1.00000 1.000e+00 1.000e+00 1.000e+00

set.seed(11)
gw=greedy.wilks(coica[,1:30], g,niveau=.15)
z=lda(gw$formula, data = as.data.frame(coica[,1:30]))

#res.man <- manova(coica[,c(-5,-9,-12,-14,-31,-32,-33)] ~ g)
#summary(res.man,test='Wilks') #Sect 11.4 Mardia
#          Df      Wilks approx F num Df den Df    Pr(>F)    
#g          1 0.00045467   507.32     26      6 4.259e-08 ***







#################
#Figure  3
##################

plot(coica[,20],coica[,11],type='n',xlab='PCA 20', ylab='PCA 11') #gw
points(coica[g==1,20],coica[g==1,11],col='blue',pch=8)
points(coica[g==2,20],coica[g==2,11],col='red',pch=19)
legend('topright',legend=c('RE','non-RE'),col=c('blue','red'),pch=c(8,19))

windows()
pe=predict(z)
plot(1:33,pe$x)

pe=predict(z)
plot(pe$x,ylab='Discriminant    values') 


#########################
#leave-one-out : LDA, selection variable
     
##############
#LDA variable selection stepclass 
##############


g=c(rep(1,15), rep(2,18));

library(MASS)
library(klaR)

niv=0.15
#niv=0.25# right

nco=c()
 
     preaire=c();
  


for (i in 1:33){

 
 pr = prcomp(cxyz[-i,]) ;
coica=pr$x
co=pr$rotation

me=apply(cxyz[-i,],2,mean)

coi=(cxyz[i,]-me)%*%co; 

et=g[-i]

gw=greedy.wilks(coica[,1:28], et,niveau=niv)


nco=c(nco, dim( gw$results[1])[1])

et=g[-i]
db=cbind(et,coica[,1:28])
z <- lda(gw$formula, as.data.frame(db))




preaire=rbind(preaire,predict(z, as.data.frame(coi))$posterior)


  }
  
  
clre=max.col(preaire[,1:2])


sum(clre==g)/33


library(caret)
confusionMatrix(as.factor(clre),as.factor(g))


nco
 
summary(nco)
   Min. 1st Qu.  Median    Mean 3rd Qu.    Max. 
  
 ###########################



